using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp17
{
    class Program
    {
        static void Main(string[] args)
        {
            string linija = Console.ReadLine();
            int N = int.Parse(linija.Split(' ')[0]);
            int M = int.Parse(linija.Split(' ')[1]);
            int[,] matrica = new int[M, 3];
            for(int i = 0; i < M; i++)
            {
                linija = Console.ReadLine();
                matrica[i, 0] = int.Parse(linija.Split(' ')[0]);
                matrica[i, 1] = int.Parse(linija.Split(' ')[1]);
                matrica[i, 2] = int.Parse(linija.Split(' ')[2]);

            }
            linija = Console.ReadLine();
            int u = int.Parse(linija.Split(' ')[0]);
            int v = int.Parse(linija.Split(' ')[1]);
          
            int br = 0;
            int pla = 0;
            int[] niz = new int[M];
            for(int i = 0; i < M; i++)
            {
                niz[matrica[i, 0]-1]++;
                niz[matrica[i, 1]-1]++;
                if (matrica[i, 2] != pla)
                {
                    if (pla == 0) pla = 1;
                    else pla = 0;
                    br++;
                }
            }
            Console.WriteLine(br);
        }
    }
}